<?php
namespace LMS\Tools\Announcements\Model;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;
use LMS\Tools\Announcements\Repositories;

defined('_JEXEC') or die;
jimport('joomla.application.component.modellist');

class Announcements extends Base\Model
{
    protected $name = 'Announcements';
    protected $course_id = null;

    //TMP where we'll save/get it params??? global or local config?
    protected $featured_items_count = 5;
    protected $items_count = 10;

    public function __construct($options)
    {
        parent::__construct($options);
        $this->repository =  ServiceLocator::get('table_announcements');
        //$this->course_id = $this->input->get('course_id', 0);
        //$this->annoncements_items_count = 3;
        //$this->annoncements_featured_items_count = 5;
    }

    public function getItems()
    {
        $this->course_id = $this->getState('course_id', 0);
        if (!$this->course_id) return null;
        $conditions = array('announcements.course_id'=> $this->course_id, 'limit'=> $this->items_count, 'announcements.featured'=> 0, 'announcement_filter'=>$this->announcement_filter);
        $items = $this->repository->getByFilter($conditions);
        return $items;
    }

    public function getFeaturedItems()
    {
        $this->course_id = $this->getState('course_id', 0);
        if (!$this->course_id) return null;
        $conditions = array('announcements.course_id'=> $this->course_id, 'limit'=> $this->featured_items_count, 'announcements.featured'=> 1, 'announcement_filter'=>$this->announcement_filter);
        $featured_items = $this->repository->getByFilter($conditions);
        return $featured_items;
    }

    public function getAllFeaturedItems()
    {
        $items = parent::getItems();
        return $items;
    }

    public function getAllActualItems()
    {
        $this->setState('announcements.course_id',$this->getState('course_id', 0) );
        $items = parent::getItems();
        return $items;
    }

    public function getItemsCount($type='')
    {
        //return 0;

        $items_count = 0;
        $this->course_id = $this->getState('course_id', 0);
        if (!$this->course_id) return null;
       // echo $type.' '.$this->course_id;
        $conditions = array('announcements.course_id'=> $this->course_id,'announcements.'.$type=>1);
        $items_count = $this->repository->getTotal($conditions);
        return $items_count;
    }
}