<?php

namespace LMS\Tools\Announcements\View;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Announcement extends Base\View
{
    public function __construct($config=array())
    {
        $this->viewDir = __DIR__;
        parent::__construct($config);
        $this->acl = ServiceLocator::get('acl');
        $this->tool_path = \Juri::root().'components/com_joomla_lms/tools/announcements';
    }

	public function display($tpl = null)
	{
        $this->addStyleSheet( $this->tool_path.'/assets/css/announcements.css');

        $model = $this->getModel();
        $this->item = $model->getItem();

        if (!$tpl)
        {
            echo new \LMS\Widgets\ContentHeader(array('title' => (isset($this->item->title)?$this->item->title:_JLMS_AGENDA_HEADTITLE), 'icon' => 'announcements'));
            $this->toolbar = $this->getDisplayToolbar();
        }else if ($tpl=='edit')
        {
            echo new \LMS\Widgets\ContentHeader(array('title' => (isset($this->item->title)?(_JLMS_EDIT.': '.$this->item->title):_JLMS_AGENDA_ADD_ITEM), 'icon' => 'announcements'));
            $this->setLayout('edit');
            $tpl = null;
        }

		return parent::display($tpl);
	}

    public function editItem()
    {
        $this->addScript($this->tool_path.'/assets/js/announcement_js_helper.js');

        $model = $this->getModel('Announcement');
        $this->form = $this->get('Form', 'Announcement');
        $this->item = $this->get('Item');
        $this->course_id = $model->getState('announcement.course_id');
        $this->toolbar = $this->getEditToolbar();
        $this->display('edit');
    }

    private function getToolbar()
    {
        jimport('cms.html.toolbar');
        $toolbar = new \JToolBar( 'toolbar' );
        return $toolbar;
    }

    protected function getEditToolbar()
    {
        $toolbar = new \LMS\Widgets\ContentToolbar();
        $toolbar->addSaveButton( array('href' => 'javascript: Joomla.submitbutton(\'announcements.announcement.save\')') );
        $toolbar->addCancelButton( array('href' => 'javascript: Joomla.submitbutton(\'announcements.announcement.cancel\')') );
        return $toolbar->render();
    }

    private function getDisplayToolbar()
    {
        $toolbar = $this->getToolbar();
        if ($this->acl->CheckPermissions('announce', 'manage') )
        {
            $toolbar->appendButton( 'Standard', 'edit', 'Edit', 'announcements.announcement.edit', false );
        }
        return $toolbar->render();
    }

}
