<?php
namespace LMS\Tools\Coursebuilder\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Coursebuilder\Tables;

class LmsMenu extends Base\Repository
{
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\LmsMenu($this->db);
	}

	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		$conditions = array();

		if(isset($filterOptions['published'])){
			$conditions[] = $alias.".published = ".$this->db->quote($filterOptions['published']);
		}

		if(isset($filterOptions['is_separator'])){
			$conditions[] = $alias.".is_separator = ".$this->db->quote($filterOptions['is_separator']);
		}

		if(isset($filterOptions['user_access'])){
			$conditions[] = $alias.".user_access = ".$this->db->quote($filterOptions['user_access']);
		}

		$query->where($conditions);

		return parent::prepareFilter($query, $filterOptions); // TODO: Change the autogenerated stub
	}


}