<?php
namespace LMS\Tools\Coursebuilder\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Coursebuilder\Tables;

class SystemMenu extends Base\Repository
{
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\SystemMenu($this->db);
	}

	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		$conditions = array();

		if(isset($filterOptions['id']) && $filterOptions['id']){
			$conditions[] = $alias.".".$this->table->getKeyName()." = ".$this->db->quote($filterOptions['id']);
		}

		if(isset($filterOptions['tool']) && !empty($filterOptions['tool'])){
			$conditions[] = $alias.".tool = ".$this->db->quote($filterOptions['tool']);
		}

		if(isset($filterOptions['course_id']) && $filterOptions['course_id']){
			$conditions[] = $alias.".course_id = ".$this->db->quote($filterOptions['course_id']);
		}

		$query->where($conditions);

		return parent::prepareFilter($query, $filterOptions); // TODO: Change the autogenerated stub
	}

	public function getJlmsSystemMenuItemByCourseId($courseId)
	{
		return $this->getByFilter(
			array(
				'tool' => 'details_course',
				'course_id' => $courseId,
				'resultType' => 'object'
			)
		);
	}
}